﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace CirkelLinje
{
    public class Game1 : Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        private Texture2D circleTexture;
        private Texture2D pixelTexture;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            circleTexture = Content.Load<Texture2D>("circle");
            pixelTexture = Content.Load<Texture2D>("pixel");
        }

        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed || Keyboard.GetState().IsKeyDown(Keys.Escape))
                Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();
            DrawCircle(new Vector2(100, 100), Color.Red, 100);
            DrawCircle(new Vector2(200, 100), Color.Green, 100);
            DrawCircle(new Vector2(200, 200), Color.Blue, 100);
            DrawLine(new Vector2(100, 100), new Vector2(200, 100), Color.Beige, 5);
            DrawLine(new Vector2(200, 100), new Vector2(200, 200), Color.Black, 10);
            DrawLine(new Vector2(200, 200), new Vector2(100, 100), Color.YellowGreen, 15);
            spriteBatch.End();

            base.Draw(gameTime);
        }

        public void DrawLine(Vector2 pos1, Vector2 pos2, Color color, int width = 1)
        {
            Vector2 diff = (pos1 - pos2);
            float length = diff.Length();
            float angle = (float)Math.Atan2(diff.Y, diff.X) + MathHelper.Pi;
            
            spriteBatch.Draw(pixelTexture, new Rectangle((int)(pos1.X), (int)(pos1.Y), (int)length, width),
                null, color, angle, new Vector2(0, width / 2), SpriteEffects.None, 0f);
        }

        public void DrawCircle(Vector2 pos, Color color, int width = 10)
        {
            float scale = width / (float)circleTexture.Width;
            spriteBatch.Draw(circleTexture, pos, null, color, 0f,
                new Vector2(circleTexture.Width * 0.5f, circleTexture.Height * 0.5f), scale, SpriteEffects.None, 0f);
        }
    }
}
